//
//  MasterViewController.swift
//  Lokalizacje2016
//
//  Created by Zdzislaw Sroczynski on 03.10.2016.
//  Copyright © 2016 Zdzislaw Sroczynski. All rights reserved.
//

import UIKit
import MapKit

class locClass{
    var latitude: Double = 0.0
    var longitude : Double = 0.0
}

class MasterViewController: UITableViewController, CLLocationManagerDelegate {

    var detailViewController: DetailViewController? = nil
    //var objects = [Any]()
    var objects = [AnyObject]()
    var locMan : CLLocationManager!
    var loc : CLLocationCoordinate2D!
    var locObj : locClass!

    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        self.navigationItem.leftBarButtonItem = self.editButtonItem

        let addButton = UIBarButtonItem(barButtonSystemItem: .add, target: self, action: #selector(insertNewObject(_:)))
        self.navigationItem.rightBarButtonItem = addButton
        if let split = self.splitViewController {
            let controllers = split.viewControllers
            self.detailViewController = (controllers[controllers.count-1] as! UINavigationController).topViewController as? DetailViewController
        }
        
        //maps
        locMan = CLLocationManager()
        locMan.requestWhenInUseAuthorization()
        locMan.delegate = self
        locMan.desiredAccuracy = kCLLocationAccuracyBest
        locMan.startMonitoringSignificantLocationChanges()
        
        locObj = locClass()
 
        
    }
    
    func locationManager(manager : CLLocationManager!, didUpdateLocations locations: [AnyObject]!)
    {
        loc = manager.location?.coordinate
        locObj.latitude = loc.latitude
        locObj.longitude = loc.longitude
        // println("loc \(loc.latitude) \(loc.longitude)")
    }

    override func viewWillAppear(_ animated: Bool) {
        self.clearsSelectionOnViewWillAppear = self.splitViewController!.isCollapsed
        super.viewWillAppear(animated)
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    func insertNewObject(_ sender: Any) {
        //objects.insert(NSDate(), at: 0)
        //let indexPath = IndexPath(row: 0, section: 0)
        //self.tableView.insertRows(at: [indexPath], with: .automatic)
        
        
        loc = locMan.location?.coordinate
        locObj.latitude = loc.latitude
        locObj.longitude = loc.longitude
        
        objects.insert(locObj, at: 0)
        let indexPath = IndexPath(row: 0, section: 0)
        self.tableView.insertRows(at:[indexPath], with: .automatic)
    }

    // MARK: - Segues

    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        if segue.identifier == "showDetail" {
            if let indexPath = self.tableView.indexPathForSelectedRow {
                let object = objects[indexPath.row] as! locClass
                
                
                
                let controller = (segue.destination as! UINavigationController).topViewController as! DetailViewController
                controller.detailItem = object
                controller.navigationItem.leftBarButtonItem = self.splitViewController?.displayModeButtonItem
                controller.navigationItem.leftItemsSupplementBackButton = true
            }
        }
    }

    // MARK: - Table View

    override func numberOfSections(in tableView: UITableView) -> Int {
        return 1
    }

    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return objects.count
    }

    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "Cell", for: indexPath)

       // let object = objects[indexPath.row] as! NSDate
       // cell.textLabel!.text = object.description
        
        let object = objects[indexPath.row] as! locClass
        cell.textLabel!.text = "\(object.latitude) \(object.longitude)"
        return cell
    
    }

    override func tableView(_ tableView: UITableView, canEditRowAt indexPath: IndexPath) -> Bool {
        // Return false if you do not want the specified item to be editable.
        return true
    }

    override func tableView(_ tableView: UITableView, commit editingStyle: UITableViewCellEditingStyle, forRowAt indexPath: IndexPath) {
        if editingStyle == .delete {
            objects.remove(at: indexPath.row)
            tableView.deleteRows(at: [indexPath], with: .fade)
        } else if editingStyle == .insert {
            // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view.
        }
    }


}

