//
//  ViewControllerCropPhoto.swift
//  XP5S2016
//
//  Created by Zdzisław Sroczyński on 25.11.2016.
//  Copyright © 2016 Zdzisław Sroczyński. All rights reserved.
//

import UIKit

extension CGRect {
    init(_ x:CGFloat, _ y:CGFloat, _ w:CGFloat, _ h:CGFloat) {
        self.init(x:x, y:y, width:w, height:h)
    }
}


extension UIImage {
    
    func crop(rect:CGRect) -> UIImage {
        let imageRef: CGImage = self.cgImage!.cropping(to: rect)!
        let resized  = UIImage(cgImage: imageRef, scale: self.scale, orientation: self.imageOrientation)
        return resized
    }
}

class ViewControllerCropPhoto: UIViewController {

    @IBOutlet weak var MyCroppedPhoto: UIImageView!
    
    @IBAction func CropPhotoClick(_ sender: AnyObject) {
        MyCroppedPhoto.image = MyCroppedPhoto.image?.crop(rect: CGRect(200,200,500,500))
    }
    
    
    @IBAction func SaveClick(_ sender: AnyObject) {
        let imageData = UIImageJPEGRepresentation(MyCroppedPhoto.image!, 0.6)
        let compressedJPGImage = UIImage(data: imageData!)
        UIImageWriteToSavedPhotosAlbum(compressedJPGImage!, nil, nil, nil)
        
        let alert = UIAlertView(title: "Hurra!",
                                message: "Obrazek został zapisany na rolce!",
                                delegate: nil,
                                cancelButtonTitle: "Ok")
        alert.show()
        
    }
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    

    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destinationViewController.
        // Pass the selected object to the new view controller.
    }
    */

}
